Package org.apache.commons.beanutils

## Class RowSetDynaClass

- java.lang.Object
- - org.apache.commons.beanutils.RowSetDynaClass

All Implemented Interfaces:
  `java.io.Serializable`, `DynaClass`

    public class RowSetDynaClass
    extends java.lang.Object
    implements DynaClass, java.io.Serializable

Implementation of `DynaClass` that creates an in-memory collection of `DynaBean`s representing the results of an SQL query. Once the `DynaClass` instance has been created, the JDBC `ResultSet` and `Statement` on which it is based can be closed, and the underlying `Connection` can be returned to its connection pool (if you are using one).

The normal usage pattern is something like:

       Connection conn = ...;  // Acquire connection from pool
       Statement stmt = conn.createStatement();
       ResultSet rs = stmt.executeQuery("SELECT ...");
       RowSetDynaClass rsdc = new RowSetDynaClass(rs);
       rs.close();
       stmt.close();
       ...;                    // Return connection to pool
       List rows = rsdc.getRows();
       ...;                   // Process the rows as desired

Each column in the result set will be represented as a `DynaBean` property of the corresponding name (optionally forced to lower case for portability). There will be one `DynaBean` in the `List` returned by `getRows()` for each row in the original `ResultSet`.

In general, instances of `RowSetDynaClass` can be serialized and deserialized, which will automatically include the list of `DynaBean`s representing the data content. The only exception to this rule would be when the underlying property values that were copied from the `ResultSet` originally cannot themselves be serialized. Therefore, a `RowSetDynaClass` makes a very convenient mechanism for transporting data sets to remote Java-based application components.

Version:
  $Id$
See Also:
  Serialized Form

### Field Summary

Fields
`protected int` `limit` Limits the size of the returned list.
`protected boolean` `lowerCase` Flag defining whether column names should be lower cased when converted to property names.
`protected DynaProperty[]` `properties` The set of dynamic properties that are part of this `DynaClass`.
`protected java.util.Map<java.lang.String,​DynaProperty>` `propertiesMap` The set of dynamic properties that are part of this `DynaClass`, keyed by the property name.
`protected java.util.List<DynaBean>` `rows` The list of `DynaBean`s representing the contents of the original `ResultSet` on which this `RowSetDynaClass` was based.

### Constructor Summary

Constructors
`RowSetDynaClass​(java.sql.ResultSet resultSet)` Construct a new `RowSetDynaClass` for the specified `ResultSet`.
`RowSetDynaClass​(java.sql.ResultSet resultSet, boolean lowerCase)` Construct a new `RowSetDynaClass` for the specified `ResultSet`.
`RowSetDynaClass​(java.sql.ResultSet resultSet, boolean lowerCase, boolean useColumnLabel)` Construct a new `RowSetDynaClass` for the specified `ResultSet`.
`RowSetDynaClass​(java.sql.ResultSet resultSet, boolean lowerCase, int limit)` Construct a new `RowSetDynaClass` for the specified `ResultSet`.
`RowSetDynaClass​(java.sql.ResultSet resultSet, boolean lowerCase, int limit, boolean useColumnLabel)` Construct a new `RowSetDynaClass` for the specified `ResultSet`.
`RowSetDynaClass​(java.sql.ResultSet resultSet, int limit)` Construct a new `RowSetDynaClass` for the specified `ResultSet`.

### Method Summary

All Methods Instance Methods Concrete Methods
`protected void` `copy​(java.sql.ResultSet resultSet)` Copy the column values for each row in the specified `ResultSet` into a newly created `DynaBean`, and add this bean to the list of `DynaBean`s that will later by returned by a call to `getRows()`.
`protected DynaBean` `createDynaBean()` Create and return a new `DynaBean` instance to be used for representing a row in the underlying result set.
`protected DynaProperty` `createDynaProperty​(java.sql.ResultSetMetaData metadata, int i)` Factory method to create a new DynaProperty for the given index into the result set metadata.
`protected java.lang.String` `getColumnName​(java.lang.String name)` Get the table column name for the specified property name.
`DynaProperty[]` `getDynaProperties()` Return an array of `ProperyDescriptors` for the properties currently defined in this DynaClass.
`DynaProperty` `getDynaProperty​(java.lang.String name)` Return a property descriptor for the specified property, if it exists; otherwise, return `null`.
`java.lang.String` `getName()` Return the name of this DynaClass (analogous to the `getName()` method of `java.lang.Class</code), which allows the same <code>DynaClass` implementation class to support different dynamic classes, with different sets of properties.
`protected java.lang.Object` `getObject​(java.sql.ResultSet resultSet, java.lang.String name)` Get a column value from a `ResultSet` for the specified name.
`java.util.List<DynaBean>` `getRows()` Return a `List` containing the `DynaBean`s that represent the contents of each `Row` from the `ResultSet` that was the basis of this `RowSetDynaClass` instance.
`protected void` `introspect​(java.sql.ResultSet resultSet)` Introspect the metadata associated with our result set, and populate the `properties` and `propertiesMap` instance variables.
`protected java.lang.Class<?>` `loadClass​(java.lang.String className)` Loads and returns the `Class` of the given name.
`DynaBean` `newInstance()` Instantiate and return a new DynaBean instance, associated with this DynaClass.
`void` `setUseColumnLabel​(boolean useColumnLabel)` Set whether the column label or name should be used for the property name.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface org.apache.commons.beanutils.DynaClass

`getDynaProperties, getDynaProperty, getName, newInstance`

### Field Detail

#### limit

    protected int limit

Limits the size of the returned list. The call to `getRows()` will return at most limit number of rows. If less than or equal to 0, does not limit the size of the result.

#### rows

    protected java.util.List<DynaBean> rows

The list of `DynaBean`s representing the contents of the original `ResultSet` on which this `RowSetDynaClass` was based.

#### lowerCase

    protected boolean lowerCase

Flag defining whether column names should be lower cased when converted to property names.

#### properties

    protected DynaProperty[] properties

The set of dynamic properties that are part of this `DynaClass`.

#### propertiesMap

    protected java.util.Map<java.lang.String,​DynaProperty> propertiesMap

The set of dynamic properties that are part of this `DynaClass`, keyed by the property name. Individual descriptor instances will be the same instances as those in the `properties` list.

### Constructor Detail

#### RowSetDynaClass

    public RowSetDynaClass​(java.sql.ResultSet resultSet)
                    throws java.sql.SQLException

Construct a new `RowSetDynaClass` for the specified `ResultSet`. The property names corresponding to column names in the result set will be lower cased.

Parameters:
  `resultSet` - The result set to be wrapped
Throws:
  `java.lang.NullPointerException` - if `resultSet` is `null`
  `java.sql.SQLException` - if the metadata for this result set cannot be introspected

#### RowSetDynaClass

    public RowSetDynaClass​(java.sql.ResultSet resultSet,
                           int limit)
                    throws java.sql.SQLException

Construct a new `RowSetDynaClass` for the specified `ResultSet`. The property names corresponding to column names in the result set will be lower cased.

If `limit` is not less than 0, max `limit` number of rows will be copied into the list.

Parameters:
  `resultSet` - The result set to be wrapped
  `limit` - The maximum for the size of the result.
Throws:
  `java.lang.NullPointerException` - if `resultSet` is `null`
  `java.sql.SQLException` - if the metadata for this result set cannot be introspected

#### RowSetDynaClass

    public RowSetDynaClass​(java.sql.ResultSet resultSet,
                           boolean lowerCase)
                    throws java.sql.SQLException

Construct a new `RowSetDynaClass` for the specified `ResultSet`. The property names corresponding to the column names in the result set will be lower cased or not, depending on the specified `lowerCase` value.

If `limit` is not less than 0, max `limit` number of rows will be copied into the resultset.

Parameters:
  `resultSet` - The result set to be wrapped
  `lowerCase` - Should property names be lower cased?
Throws:
  `java.lang.NullPointerException` - if `resultSet` is `null`
  `java.sql.SQLException` - if the metadata for this result set cannot be introspected

#### RowSetDynaClass

    public RowSetDynaClass​(java.sql.ResultSet resultSet,
                           boolean lowerCase,
                           int limit)
                    throws java.sql.SQLException

Construct a new `RowSetDynaClass` for the specified `ResultSet`. The property names corresponding to the column names in the result set will be lower cased or not, depending on the specified `lowerCase` value.

WARNING - If you specify `false` for `lowerCase`, the returned property names will exactly match the column names returned by your JDBC driver. Because different drivers might return column names in different cases, the property names seen by your application will vary depending on which JDBC driver you are using.

Parameters:
  `resultSet` - The result set to be wrapped
  `lowerCase` - Should property names be lower cased?
  `limit` - Maximum limit for the `List` of `DynaBean`
Throws:
  `java.lang.NullPointerException` - if `resultSet` is `null`
  `java.sql.SQLException` - if the metadata for this result set cannot be introspected

#### RowSetDynaClass

    public RowSetDynaClass​(java.sql.ResultSet resultSet,
                           boolean lowerCase,
                           boolean useColumnLabel)
                    throws java.sql.SQLException

Construct a new `RowSetDynaClass` for the specified `ResultSet`. The property names corresponding to the column names in the result set will be lower cased or not, depending on the specified `lowerCase` value.

WARNING - If you specify `false` for `lowerCase`, the returned property names will exactly match the column names returned by your JDBC driver. Because different drivers might return column names in different cases, the property names seen by your application will vary depending on which JDBC driver you are using.

Parameters:
  `resultSet` - The result set to be wrapped
  `lowerCase` - Should property names be lower cased?
  `useColumnLabel` - true if the column label should be used, otherwise false
Throws:
  `java.lang.NullPointerException` - if `resultSet` is `null`
  `java.sql.SQLException` - if the metadata for this result set cannot be introspected
Since:
  1.8.3

#### RowSetDynaClass

    public RowSetDynaClass​(java.sql.ResultSet resultSet,
                           boolean lowerCase,
                           int limit,
                           boolean useColumnLabel)
                    throws java.sql.SQLException

Construct a new `RowSetDynaClass` for the specified `ResultSet`. The property names corresponding to the column names in the result set will be lower cased or not, depending on the specified `lowerCase` value.

WARNING - If you specify `false` for `lowerCase`, the returned property names will exactly match the column names returned by your JDBC driver. Because different drivers might return column names in different cases, the property names seen by your application will vary depending on which JDBC driver you are using.

Parameters:
  `resultSet` - The result set to be wrapped
  `lowerCase` - Should property names be lower cased?
  `limit` - Maximum limit for the `List` of `DynaBean`
  `useColumnLabel` - true if the column label should be used, otherwise false
Throws:
  `java.lang.NullPointerException` - if `resultSet` is `null`
  `java.sql.SQLException` - if the metadata for this result set cannot be introspected
Since:
  1.8.3

### Method Detail

#### getRows

    public java.util.List<DynaBean> getRows()

Return a `List` containing the `DynaBean`s that represent the contents of each `Row` from the `ResultSet` that was the basis of this `RowSetDynaClass` instance. These `DynaBean`s are disconnected from the database itself, so there is no problem with modifying the contents of the list, or the values of the properties of these `DynaBean`s. However, it is the application's responsibility to persist any such changes back to the database, if it so desires.

Returns:
  A `List` of `DynaBean` instances

#### copy

    protected void copy​(java.sql.ResultSet resultSet)
                 throws java.sql.SQLException

Copy the column values for each row in the specified `ResultSet` into a newly created `DynaBean`, and add this bean to the list of `DynaBean`s that will later by returned by a call to `getRows()`.

Parameters:
  `resultSet` - The `ResultSet` whose data is to be copied
Throws:
  `java.sql.SQLException` - if an error is encountered copying the data

#### createDynaBean

    protected DynaBean createDynaBean()

Create and return a new `DynaBean` instance to be used for representing a row in the underlying result set.

Returns:
  A new `DynaBean` instance

#### getName

    public java.lang.String getName()

Return the name of this DynaClass (analogous to the `getName()` method of `java.lang.Class</code), which allows the same <code>DynaClass` implementation class to support different dynamic classes, with different sets of properties.

Specified by:
  `getName` in interface `DynaClass`
Returns:
  the name of the DynaClass

#### getDynaProperty

    public DynaProperty getDynaProperty​(java.lang.String name)

Return a property descriptor for the specified property, if it exists; otherwise, return `null`.

Specified by:
  `getDynaProperty` in interface `DynaClass`
Parameters:
  `name` - Name of the dynamic property for which a descriptor is requested
Returns:
  The descriptor for the specified property
Throws:
  `java.lang.IllegalArgumentException` - if no property name is specified

#### getDynaProperties

    public DynaProperty[] getDynaProperties()

Return an array of `ProperyDescriptors` for the properties currently defined in this DynaClass. If no properties are defined, a zero-length array will be returned.

Specified by:
  `getDynaProperties` in interface `DynaClass`
Returns:
  the set of properties for this DynaClass

#### newInstance

    public DynaBean newInstance()
                         throws java.lang.IllegalAccessException,
                                java.lang.InstantiationException

Instantiate and return a new DynaBean instance, associated with this DynaClass. NOTE - This operation is not supported, and throws an exception.

Specified by:
  `newInstance` in interface `DynaClass`
Returns:
  A new `DynaBean` instance
Throws:
  `java.lang.IllegalAccessException` - if the Class or the appropriate constructor is not accessible
  `java.lang.InstantiationException` - if this Class represents an abstract class, an array class, a primitive type, or void; or if instantiation fails for some other reason

#### setUseColumnLabel

    public void setUseColumnLabel​(boolean useColumnLabel)

Set whether the column label or name should be used for the property name.

Parameters:
  `useColumnLabel` - true if the column label should be used, otherwise false

#### loadClass

    protected java.lang.Class<?> loadClass​(java.lang.String className)
                                    throws java.sql.SQLException

Loads and returns the `Class` of the given name. By default, a load from the thread context class loader is attempted. If there is no such class loader, the class loader used to load this class will be utilized.

Parameters:
  `className` - The name of the class to load
Returns:
  The loaded class
Throws:
  `java.sql.SQLException` - if an exception was thrown trying to load the specified class

#### createDynaProperty

    protected DynaProperty createDynaProperty​(java.sql.ResultSetMetaData metadata,
                                              int i)
                                       throws java.sql.SQLException

Factory method to create a new DynaProperty for the given index into the result set metadata.

Parameters:
  `metadata` - is the result set metadata
  `i` - is the column index in the metadata
Returns:
  the newly created DynaProperty instance
Throws:
  `java.sql.SQLException` - If an error occurs accessing the SQL metadata

#### introspect

    protected void introspect​(java.sql.ResultSet resultSet)
                       throws java.sql.SQLException

Introspect the metadata associated with our result set, and populate the `properties` and `propertiesMap` instance variables.

Parameters:
  `resultSet` - The `resultSet` whose metadata is to be introspected
Throws:
  `java.sql.SQLException` - if an error is encountered processing the result set metadata

#### getObject

    protected java.lang.Object getObject​(java.sql.ResultSet resultSet,
                                         java.lang.String name)
                                  throws java.sql.SQLException

Get a column value from a `ResultSet` for the specified name.

Parameters:
  `resultSet` - The result set
  `name` - The property name
Returns:
  The value
Throws:
  `java.sql.SQLException` - if an error occurs

#### getColumnName

    protected java.lang.String getColumnName​(java.lang.String name)

Get the table column name for the specified property name.

Parameters:
  `name` - The property name
Returns:
  The column name (which can be different if the lowerCase option is used).